/* No representations are made concerning either the merchantability of
   this software or the suitability of this software for any particular
   purpose. It is provided "as is" without express or implied warranty
   of any kind.

   License to copy and use this software is granted provided that these
   notices are retained in any copies of any part of this documentation
   and/or software.
 */

class MicrolazeConfig {
public:
	MicrolazeConfig ();
	BOOL loadFromFile (char *filename);
	BOOL saveToFile (char *filename);

	char *wavelengthName() {return "wavelength";}
	int wavelength() {return _wavelength;}
	char *wavelengthString();
	void setWavelength (char *value);

	char *energyRangeName() {return "energyrange";}
	int energyRange() {return _energyRange;}
	char *energyRangeString();
	void setEnergyRange (char *value);

	char *energyLevelName() {return "energylevel";}
	int energyLevel() {return _energyLevel;}	
	void setEnergyLevel (char *value);

	char *pulseRateName() {return "pulserate";}
	int pulseRate() {return _pulseRate;}
	void setPulseRate (char *value);

	char *markerSizeXName() {return "markersizeX";}
	int markerSizeX() {return _markerSizeX;}
	void setMarkerSizeX (char *value);

	char *markerSizeYName() {return "markersizeY";}
	int markerSizeY() {return _markerSizeY;}
	void setMarkerSizeY (char *value);

	char *scoreStepSizeName() {return "scorestepsize";}
	double scoreStepSize() {return _scoreStepSize;}
	void setScoreStepSize (char *value);

	char *cutStepSizeName() {return "cutstepsize";}
	double cutStepSize() {return _cutStepSize;}
	void setCutStepSize (char *value);

	char *distanceToRefocusName() {return "distanceToRefocus";}
	double distanceToRefocus() {return _distanceToRefocus;}
	void setDistanceToRefocus (char *value);

	char *focusOffcenterDistanceName() {return "focusOffcenterDistance";}
	double focusOffcenterDistance() {return _focusOffcenterDistance;}
	void setFocusOffcenterDistance (char *value);

	char *scoreHoldTimeName() {return "scoreHoldTime";}
	double scoreHoldTime() {return _scoreHoldTime;}
	void setScoreHoldTime (char *value);

	char *cutHoldTimeName() {return "cutHoldTime";}
	double cutHoldTime() {return _cutHoldTime;}
	void setCutHoldTime (char *value);

	char *minFocusScoreName() {return "minFocusScore";}
	int minFocusScore() {return _minFocusScore;}
	void setMinFocusScore (char *value);

	char *cutFeedSpeedName() {return "cutFeedSpeed";}
	int cutFeedSpeed() {return _cutFeedSpeed;}
	void setCutFeedSpeed (char *value);

private:
	// These have the same meanings as used in Quiklaze and Prior
	int _wavelength, _energyRange, _energyLevel, _pulseRate, _markerSizeX, _markerSizeY;
	double _scoreStepSize, _cutStepSize, _distanceToRefocus, _focusOffcenterDistance;
	double _scoreHoldTime, _cutHoldTime;
	int _cutFeedSpeed, _minFocusScore;
};

