/* No representations are made concerning either the merchantability of
   this software or the suitability of this software for any particular
   purpose. It is provided "as is" without express or implied warranty
   of any kind.

   License to copy and use this software is granted provided that these
   notices are retained in any copies of any part of this documentation
   and/or software.
 */

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>
#include <windowsx.h>
#include "offset.h"
#include "quiklaze.h"
#include "prior.h"

int main(int argc, char* argv[])
{
	char buffer[80], *offsetFilename;
	double x, y, xOffset, yOffset, angle;

	if (argc != 2) {
		// Had more than one non-option parameter
	    puts ("Usage: microlazeoffset offsetfile");
		return (0);
	}

	offsetFilename = argv[1];

	MicrolazeOffset offset;

	// Don't move the stage
	Prior prior (FALSE);

	printf ("                                                                           \r");
	printf ("Use joystick to position at the origin, then hit ENTER: ");
	gets (buffer);
	
	prior.getXY (&xOffset, &yOffset);

	printf ("                                                                           \r");
	printf ("Use joystick to position along positive X axis, then hit ENTER: ");
	gets (buffer);
	
	prior.getXY (&x, &y);
	angle = atan2 (y - yOffset, x - xOffset);

	offset.setXOffset (xOffset);
	offset.setYOffset (yOffset);
	offset.setAngleOffset (angle);

	if (offset.saveToFile (offsetFilename) == FALSE)
		// already printed the error
		return (0);

	printf ("                                                                           \r");
	printf ("Wrote new offset file %s\n", offsetFilename);

	return 0;
}
