/* No representations are made concerning either the merchantability of
   this software or the suitability of this software for any particular
   purpose. It is provided "as is" without express or implied warranty
   of any kind.

   License to copy and use this software is granted provided that these
   notices are retained in any copies of any part of this documentation
   and/or software.
 */

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>
#include <windowsx.h>
#include "quiklaze.h"
#include "prior.h"

void Usage ()
{
    puts ("Usage: stagexy [x y]");
	puts ("  With no arguments, this displays the current position.");
	puts ("  x and y are in millimeters.");
}

int main(int argc, char* argv[])
{
	double x, y, newX, newY;

	if (! (argc == 1 || argc == 3)) {
		Usage ();
		return (0);
	}

	if (argc == 3) {
		// Read x and y arguments
		if (sscanf (argv[1], "%lf", &x) != 1 || sscanf (argv[2], "%lf", &y) != 1) {
			Usage ();
			return (0);
		}
	}

	// Only connect to the stage when the are no error in usage.
	Prior prior (FALSE);

	if (argc == 3) {
		// Make sure we don't refocus, and reposition
		prior.setDistanceToRefocus (0.);
		printf ("                                                                           \r");
		puts ("Repositioning...");
		prior.reposition (x, y);
	}

	// Even if we just repositioned, ask for the present position anyway
	prior.getXY (&newX, &newY);
	printf ("                                                                           \r");
	printf ("Stage now at (%.04lf, %.04lf) millimeters\n", newX, newY);
	
	return 0;
}
